using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Net;

namespace WebPageInfoSample
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtURL;
		protected System.Web.UI.WebControls.Button btnParse;
		protected Components4U.Web.WebPageInfo PageInfo = new Components4U.Web.WebPageInfo();
		protected System.Web.UI.WebControls.DataGrid dtgLinks;
		protected System.Web.UI.WebControls.Label lblTitle;
		protected System.Web.UI.WebControls.DataGrid dtgImages;
		protected System.Data.DataTable dtLinks = new DataTable();
		protected System.Data.DataTable dtImages = new DataTable();
		protected System.Web.UI.WebControls.DataGrid dtgFlashes;
		protected System.Data.DataTable dtFlashes = new DataTable();
		protected System.Web.UI.WebControls.DataGrid dtgDescriptions;
		protected System.Data.DataTable dtDescriptions = new DataTable();
		protected System.Web.UI.WebControls.DataGrid dtgKeywords;
		protected System.Data.DataTable dtKeywords = new DataTable();
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnParse.Click += new System.EventHandler(this.btnParse_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnParse_Click(object sender, System.EventArgs e)
		{
			try
			{
				// if you configured the using of proxy in Web.config settings than set global connection settings
				proxyConnect();
				
				//set the URL property and connect to the correspondent page
				PageInfo.URL = txtURL.Text;	
				PageInfo.Navigate();
				
				// Retrieve and show Title, Description, Keywords, Links, Images and Flashes of the required page
				lblTitle.Text = "Title: " + PageInfo.Title;
				getLinks();
				getImages();
				getFlashes();
				getDescriptions();
				getKeywords();
			}
			catch (Exception ex)
			{
				lblTitle.Text = ex.Message;
			}


		}
		
		// ProxyConnect() function configures the global connection settings if you are using proxy. Please set the required settings in you Web.config file
		private void proxyConnect()
		{
			System.Configuration.AppSettingsReader ar = new System.Configuration.AppSettingsReader();
			try
			{
				if (ar.GetValue("PROXY_REQUIRED", typeof(String)).ToString()=="Y")
				{
					String proxyServer = ar.GetValue("PROXY_SERVER_NAME", typeof(String)).ToString();
					String proxyProtocol = ar.GetValue("PROXY_PROTOCOL", typeof(String)).ToString();
					int proxyPort = (int)ar.GetValue("PROXY_PORT", typeof(int));

					UriBuilder url = new UriBuilder(proxyProtocol,proxyServer ,proxyPort);
					WebProxy wp = new WebProxy(url.Uri, true);
					if (ar.GetValue("PROXY_REQUIRED", typeof(String)).ToString() == "Y")
					{
						String proxyUser = ar.GetValue("PROXY_USER", typeof(String)).ToString();
						String proxyPassword = ar.GetValue("PROXY_PASSWORD", typeof(String)).ToString();
						String proxyDomain = ar.GetValue("PROXY_USER_DOMAIN", typeof(String)).ToString();
					
						NetworkCredential myCredentials = new NetworkCredential(proxyUser,proxyPassword);
						myCredentials.Domain = proxyDomain;
						wp.Credentials = myCredentials;
					}
					GlobalProxySelection.Select = wp;
				}
			}
			catch(Exception ex)
			{
				lblTitle.Text = ex.Message;
			}
		}


		// getLinks() function retrieves and shows in DataTable all links of the page
		private void getLinks()
		{
			int cnt = 0;
			dtLinks.Columns.Add("URL",typeof(string));
			
			while (cnt < PageInfo.Links.Count)
			{
				dtLinks.Rows.Add(new Object[]{PageInfo.Links[cnt]});
				cnt++;
			}
			
			dtgLinks.DataSource = new DataView(dtLinks);
			dtgLinks.DataBind();
		}

		// getImages() function retrieves and shows in DataTable all images of the page
		private void getImages()
		{
			int cnt = 0;
			dtImages.Columns.Add("imURL",typeof(string));
			dtImages.Columns.Add("imName",typeof(string));

			while (cnt < PageInfo.Images.Count)
			{
				dtImages.Rows.Add(new Object[]{PageInfo.Images[cnt],PageInfo.Images[cnt]});
				cnt++;
			}
			
			dtgImages.DataSource = new DataView(dtImages);
			dtgImages.DataBind();
		}

		// getFlashes() function retrieves and shows in DataTable all flash movies of the page
		private void getFlashes()
		{
			int cnt = 0;
			dtFlashes.Columns.Add("flURL",typeof(string));
			dtFlashes.Columns.Add("flName",typeof(string));

			while (cnt < PageInfo.Flashes.Count)
			{
				dtFlashes.Rows.Add(new Object[]{PageInfo.Flashes[cnt],PageInfo.Flashes[cnt]});
				cnt++;
			}
			
			dtgFlashes.DataSource = new DataView(dtFlashes);
			dtgFlashes.DataBind();
		}

		// getDescriptions() function retrieves and shows in DataTable all Description tags values of the page
		private void getDescriptions()
		{
			int cnt = 0;
			dtDescriptions.Columns.Add("Lang",typeof(string));
			dtDescriptions.Columns.Add("Description",typeof(string));

			while (cnt < PageInfo.Descriptions.Count)
			{
				dtDescriptions.Rows.Add(new Object[]{PageInfo.Descriptions[cnt].Lang,PageInfo.Descriptions[cnt].Description});
				cnt++;
			}
			
			dtgDescriptions.DataSource = new DataView(dtDescriptions);
			dtgDescriptions.DataBind();
		}

		// getKeywords() function retrieves and shows in DataTable all Keywords tags values of the page
		private void getKeywords()
		{
			int cnt = 0;
			int keycnt;
			String KeywordsString="";

			dtKeywords.Columns.Add("Lang",typeof(string));
			dtKeywords.Columns.Add("Keywords",typeof(string));

			while (cnt < PageInfo.KeyWords.Count)
			{

				for (keycnt=0; keycnt<PageInfo.KeyWords[cnt].KeyWords.Length; keycnt++)
				{
									KeywordsString = KeywordsString + PageInfo.KeyWords[cnt].KeyWords[keycnt] + " ,";
				}
				dtKeywords.Rows.Add(new Object[]{PageInfo.KeyWords[cnt].Lang,KeywordsString});
				cnt++;
				KeywordsString = "";
			}
			
			dtgKeywords.DataSource = new DataView(dtKeywords);
			dtgKeywords.DataBind();
		}
	}
}
